export function preloadImages(images, options) {
    if(typeof images === 'string') images = [images];
    
    if(
        (images === null)
        ||
        (typeof images === 'object' && images.length === 0)
        ||
        (typeof images === 'undefined')
    )
        return new Promise(resolve => resolve([])); 
    
    const promises = [];
    
    let progress = 0, doneCount = 0, total = images.length - 1;

    for(let src of images) {
        let tempImage = new Image();
        tempImage.src = src;
    
        promises.push(new Promise(resolve => tempImage.addEventListener('load', function() {
            doneCount++;
            progress = 100 / total * doneCount;
            
            if(typeof options === 'object') {
                if(typeof options.oneach === 'function') {
                    options.oneach(this.src);
                }
                
                if(typeof options.onprogress === 'function') {
                    options.onprogress(progress, [doneCount, total]);
                }
            }
            
            resolve(this.src);
        })));
    }

    return Promise.all(promises);
}